// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: get_token_info.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const getTokenInfoDelegatedServiceConnection = `-- name: GetTokenInfoDelegatedServiceConnection :one
SELECT
    c.group_id,
    gdsc.service_name as service_name,
    gdsc.public_key_thumbprint as public_key_thumbprint,
    gdsc.delegator_peer_id as outway_delegator_peer_id,
    gdsc.service_publication_delegator_peer_id as service_publication_delegator_peer_id
FROM
    contracts.grants_delegated_service_connection as gdsc
    JOIN contracts.valid_contracts as vc
        ON vc.hash = gdsc.content_hash
    JOIN contracts.content as c
        ON c.hash = vc.hash
WHERE
    gdsc.hash = $1::text
    AND gdsc.outway_peer_id = $2::text
    AND gdsc.service_peer_id = $3::text
`

type GetTokenInfoDelegatedServiceConnectionParams struct {
	Hash         string
	OutwayPeerID string
	SelfPeerID   string
}

type GetTokenInfoDelegatedServiceConnectionRow struct {
	GroupID                           string
	ServiceName                       string
	PublicKeyThumbprint               string
	OutwayDelegatorPeerID             string
	ServicePublicationDelegatorPeerID pgtype.Text
}

func (q *Queries) GetTokenInfoDelegatedServiceConnection(ctx context.Context, arg *GetTokenInfoDelegatedServiceConnectionParams) (*GetTokenInfoDelegatedServiceConnectionRow, error) {
	row := q.db.QueryRow(ctx, getTokenInfoDelegatedServiceConnection, arg.Hash, arg.OutwayPeerID, arg.SelfPeerID)
	var i GetTokenInfoDelegatedServiceConnectionRow
	err := row.Scan(
		&i.GroupID,
		&i.ServiceName,
		&i.PublicKeyThumbprint,
		&i.OutwayDelegatorPeerID,
		&i.ServicePublicationDelegatorPeerID,
	)
	return &i, err
}

const getTokenInfoServiceConnection = `-- name: GetTokenInfoServiceConnection :one

SELECT
    c.group_id,
    gsc.service_name as service_name,
    gsc.public_key_thumbprint as public_key_thumbprint,
    gsc.service_publication_delegator_peer_id as service_publication_delegator_peer_id
FROM
    contracts.grants_service_connection as gsc
    JOIN contracts.valid_contracts as vc
        ON vc.hash = gsc.content_hash
    JOIN contracts.content as c
        ON c.hash = vc.hash
WHERE
    gsc.hash = $1::text
    AND gsc.outway_peer_id = $2::text
    AND gsc.service_peer_id = $3::text
`

type GetTokenInfoServiceConnectionParams struct {
	Hash         string
	OutwayPeerID string
	SelfPeerID   string
}

type GetTokenInfoServiceConnectionRow struct {
	GroupID                           string
	ServiceName                       string
	PublicKeyThumbprint               string
	ServicePublicationDelegatorPeerID pgtype.Text
}

// Copyright © VNG Realisatie 2022
// Licensed under the EUPL
func (q *Queries) GetTokenInfoServiceConnection(ctx context.Context, arg *GetTokenInfoServiceConnectionParams) (*GetTokenInfoServiceConnectionRow, error) {
	row := q.db.QueryRow(ctx, getTokenInfoServiceConnection, arg.Hash, arg.OutwayPeerID, arg.SelfPeerID)
	var i GetTokenInfoServiceConnectionRow
	err := row.Scan(
		&i.GroupID,
		&i.ServiceName,
		&i.PublicKeyThumbprint,
		&i.ServicePublicationDelegatorPeerID,
	)
	return &i, err
}
